<?php
/**
 * Base Functions (Common for ALL pages)
 *
 * $Id: fnc_base.inc.php, 2004/05/05 23:47:16 Exp $
 */
 

//================================================================
// MySQL
//================================================================
/**
 * MySQL Connection
 */
function db_connect($dbname, $host, $user, $password) 
{
    $link = @mysql_pconnect($host, $user, $password);
    if ($link && mysql_select_db($dbname)) {
        return($link);
    } else {
        reporterror();
        return(FALSE);
    }
}

// MySQL connection error report
function reporterror() 
{
    if (mysql_error()) {
        die("<h2>MySQL error</h2> " . mysql_errno() . " : " . mysql_error());
    } else {
        die("<h3>I don't know why I can't connect to MySQL</h3>");
    }
}

// unicode converting
function convert_to_utf8($enable_unicode, $row, $mysql_lang) 
{
    if ($enable_unicode == 'on') {
        if (function_exists('mb_convert_variables')) {
//            $row = mb_convert_variables("UTF-8", $mysql_lang, $row);
            $var = array($row);
            $row = mb_convert_variables("UTF-8", $mysql_lang, $var);
        } else {
            return $row;
        }
    }
}


//================================================================
// SESSION
//================================================================
function session_control() {
    global $use_session_db, $cd, $admin_dir_name, $p_blog_sess_name,
           $session_status, $admin;
    if ($use_session_db == 'yes') {
        require_once $cd . '/' . $admin_dir_name . '/db_session.php';
    } else {
        session_name($p_blog_sess_name);
        session_start();
    }
    if (isset($_SESSION['admin_login'], $_SESSION['user_name'], $_SESSION['user_pass'])) {
        $sql = 'SELECT user_id FROM p_blog_user'.
               " WHERE user_pass = '". $_SESSION['user_pass'] ."'".
               " AND user_name = '". $_SESSION['user_name'] ."' LIMIT 1";
        $res = mysql_query($sql);
        $row = mysql_num_rows($res);
        if ($row != 0) {
            $session_status = 'on';
            $admin = 'yes';
        } else {
            $session_status = 'off';
            $admin = '';
            $_SESSION['admin_login'] = 0;
            $_SESSION['user_name']   = 0;
            $_SESSION['user_pass']   = 0;
            session_unset();
            session_destroy();
               
        }
    } else {
        $session_status = 'off';
        $admin = '';  
        $_SESSION['admin_login'] = 0;
        $_SESSION['user_name']   = 0;
        $_SESSION['user_pass']   = 0;
        session_unset();
        session_destroy();
    }
}

//================================================================
// HEADER-BOX
//================================================================
/**
 * XHTML Header
 */
function display_header() 
{
    global $xml_version, $lang, $charset, $xml_lang, $blog_title, $cd, $style_num, $style, $sub_title, $row,
           $request_uri, $root_path, $file_index_title, $vars_page_title, $more_vars_dir, $more_vars_title;
    // create a title bar strings
    $separator = ' : ';
    $p_blog_path = 'http://' . $_SERVER["HTTP_HOST"] . $root_path;

    // for contents
    if ($request_uri == $p_blog_path . 'index.php') {
        $page_title = $blog_title;
    } elseif (preg_match('/files/', $request_uri)) { 
        if (preg_match('/search_plus/', $request_uri)) {
            $page_title = $blog_title . $separator . $file_index_title . $separator . $lang['advanced_search'];
        } else {
            $page_title = $blog_title . $separator . $file_index_title;
        }
    } elseif ($request_uri == $p_blog_path .  'var/index.php') {
        $page_title = $blog_title . $separator . $vars_page_title;
    } elseif ($request_uri == $p_blog_path . $more_vars_dir . '/index.php') {
        $page_title = $blog_title . $separator . $more_vars_title;
    } elseif (($request_uri == $p_blog_path . 'search.php') or ($request_uri == $p_blog_path . 'bin_search.php')) {
        $page_title = $blog_title . $separator . $lang['archives'];
    } elseif (($request_uri == $p_blog_path . 'search_plus.php') or ($request_uri == $p_blog_path . 'bin_search_plus.php')) {
        $page_title = $blog_title . $separator . $lang['advanced_search'];
    } elseif (($request_uri == $p_blog_path . 'category.php') or ($request_uri == $p_blog_path . 'bin_category.php')) {
        $page_title = $blog_title . $separator . $lang['category'];
    } elseif (preg_match('/forum/', $request_uri)) {
        if (preg_match('/admin/', $request_uri)) {
            $page_title = $blog_title . $separator . $lang['admin'] . $separator . $lang['forum'];
        } else {
            $page_title = $blog_title . $separator . $lang['forum'];
        }
    // for individual pages
    } elseif (isset($row['name'])) {
        $page_title = $blog_title . $separator . $row['name'];
    } elseif (isset($row['bin_title'])) {
        $page_title = $blog_title . $separator . $row['bin_title'];
    // for admin pages
    } else {
        $page_title = $blog_title . $separator . $lang['admin'];
    }
    // addtions
    if (isset($_GET['k']) && ($_GET['k'] != '')) {
        $k = htmlspecialchars($_GET['k']);
        $page_title .= $separator . $k;
    }
    if (isset($_GET['d']) && ($_GET['d'] != '')) {
        if (!isset($_GET['ds'])) {
            $d = htmlspecialchars($_GET['d']);
            $page_title .= $separator . $d;
        }
    }
    switch ($xml_version) {
        case '1.1':
            $dtd =<<<EODTD
<?xml version="1.0" encoding="{$charset}"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
                      "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="{$xml_lang}">
EODTD;
            $content_type =<<<EOCT
<meta http-equiv="content-type" content="application/xhtml+xml; charset={$charset}" />
EOCT;
            break;
        default :
            $dtd =<<<EODTD
<?xml version="1.0" encoding="{$charset}"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="{$xml_lang}" lang="{$xml_lang}">
EODTD;
            $content_type =<<<EOCT
<meta http-equiv="content-type" content="text/html; charset={$charset}" />
EOCT;
            break;
    }
    echo <<<EOD
{$dtd}
<head>
<title>{$page_title}</title>
{$content_type}
<meta http-equiv="content-script-type" content="text/javascript" />
<script type="text/javascript" src="{$cd}/include/scripts.js"></script>
<meta http-equiv="content-style-type" content="text/css" />
<link rel="stylesheet" type="text/css" href="{$cd}/styles/{$style_num}/{$style}.css" />
<link rev="made" href="mailto:webmaster@anti-spam.example.com" />
<link rel="start" href="{$cd}/index.php" />
<script type="text/javascript" src="{$cd}/include/block_spam.php?js_email_link"></script>
</head>
<body>
<!-- header-box -->
<div class="header">
<h1 class="title"><a href="{$cd}/index.php" class="title">{$blog_title}</a></h1>
<span class="subtitle">{$sub_title}</span>

EOD;
}

// XHTML 1.0 strict
//<meta http-equiv="content-type" content="text/html; charset={$charset}" />
// XHTML 1.1
//<meta http-equiv="content-type" content="application/xhtml+xml; charset={$charset}" />

//================================================================
// MENU-BOX
//================================================================
/**
 * Menu List (Contents Navigation)
 */
function display_menu_list($cd, $admin, $menu_list, $root_path) 
{
    global $lang, $admin_dir_name, $add;
    if (isset($_GET['add'])) {
        $add = $_GET['add'];
    }
    echo <<<EOD

</div>
<!-- end-of-header-box -->
<!-- menu-box -->
<div class="menu-box">
EOD;
    $request_uri = 'http://' . $_SERVER["HTTP_HOST"] . $_SERVER['SCRIPT_NAME'];
    $p_blog_path = 'http://' . $_SERVER["HTTP_HOST"] . $root_path;
    
    // 管理モードのメニューを表示
    if ($admin == 'yes') {
        echo "\n".'<h2 class="menu-box">'.
             '<a href="http://' . $_SERVER["HTTP_HOST"] . $root_path . $admin_dir_name . '/admin_top.php">' .
             $lang['admin'] . "</a></h2>\n";
         
        // 普通の管理者
        if ((isset($_SESSION['admin_login'])) && ($_SESSION['admin_login'] != '')) {
            $logout = '<div id="logout">'."\n".
                      '<a href="http://' . $_SERVER["HTTP_HOST"] . $root_path . $admin_dir_name . '/login.php?status=logout">'.
                      $lang['logout'].
                      "</a>\n</div>\n";
            $admin_menu   = '　<h3>'.$lang['add_new']."</h3>\n".
                            '<ul class="menu">'."\n";
            if (($request_uri . '?add=' . $add) == ($p_blog_path . $admin_dir_name . '/add.php?add=log')) {
                $admin_menu .= '<li class="cur-menu">'.$lang['log']. "</li>\n".
                               '<li class="menu"><a href="' . $p_blog_path . $admin_dir_name . '/add.php?add=bin" class="menu">'.
                               $lang['file'].
                               "</a></li>\n";
            } elseif (($request_uri . '?add=' . $add) == ($p_blog_path . $admin_dir_name . '/add.php?add=bin')) {
                $admin_menu .= '<li class="menu">'.
                               '<a href="' . $p_blog_path . $admin_dir_name . '/add.php?add=log" class="menu">'.
                               $lang['log'].
                               "</a></li>\n".
                               '<li class="cur-menu">'.$lang['file']. "</li>\n";
            } else {
                $admin_menu .= '<li class="menu">'.
                               '<a href="' . $p_blog_path . $admin_dir_name . '/add.php?add=log" class="menu">'.
                               $lang['log'] . "</a></li>\n".
                               '<li class="menu">'.
                               '<a href="' . $p_blog_path . $admin_dir_name . '/add.php?add=bin" class="menu">'.
                               $lang['file'] . "</a></li>\n";
            }
            $admin_menu .= '</ul>';
                 
            $menu_mod_del  = '<h3>' . $lang['mod_del'] . '</h3>';
            $menu_mod_del .= '<ul class="menu">';
            if(isset($_GET['id'])){ 
                 $id = addslashes($_GET['id']); 
            }
            foreach ($menu_list as $key => $value) {
                if ((((isset($id)) && ($id != "") && 
                    (($request_uri."?id=".$id) == $p_blog_path . preg_replace('/^.\//', '', $value)))) ||
                    (((!isset($id)) && ($request_uri == $p_blog_path . preg_replace('/^.\//', '', $value))))) {
                    $menu_mod_del .= '<li class="cur-menu">'.$key."</li>\n";
                } elseif (preg_match('/^http:\/\//', $value)) {
                    $menu_mod_del .= '<li class="menu"><a href="'.$value.'" class="menu">'.$key."</a></li>\n";
                } else { 
                    $menu_mod_del .= '<li class="menu"><a href="'.$cd.'/'.$value.'" class="menu">'.$key."</a></li>\n";
                }
            }
            $menu_mod_del .= "</ul>\n";
            $session_user = $_SESSION['user_name'];
         
        // ルート管理者
        } elseif ((isset($_SESSION['root_admin_login'])) && ($_SESSION['root_admin_login'] != '')) {
            $logout = '<div id="logout">'.
                      '<a href="http://' . $_SERVER["HTTP_HOST"] . $root_path . $admin_dir_name . '/root/root_login.php?status=logout">'.
                      $lang['logout'].'</a></div>';
            $admin_menu = '';
            $menu_mod_del = '';
            $session_user = $_SESSION['root_user_name'];

        // セッション切れ
        } else {
            $logout = '';
            $admin_menu = '';
            $menu_mod_del = '';
            $session_user = $lang['none'];
        }    

        echo <<<EOD
<div class="menu">
<h2>{$lang['login_user']}</h2>
<p>{$session_user}</p>
{$logout}</div>
<hr />
{$admin_menu}
EOD;
        // 以下のファイルがリクエストファイルの場合はドラフト数を表示
        if (($request_uri == $p_blog_path . $admin_dir_name . '/add.php') ||
            ($request_uri == $p_blog_path . $admin_dir_name . '/draft_list.php') ||
            ($request_uri == $p_blog_path . $admin_dir_name . '/draft_update.php') ||
            ($request_uri == $p_blog_path . $admin_dir_name . '/draft_updated.php') ||
            ($request_uri == $p_blog_path . $admin_dir_name . '/draft_preview.php') ||
            ($request_uri == $p_blog_path . $admin_dir_name . '/draft_publish.php') ||
            ($request_uri == $p_blog_path . $admin_dir_name . '/bin_draft_list.php') ||
            ($request_uri == $p_blog_path . $admin_dir_name . '/bin_draft_update.php') ||
            ($request_uri == $p_blog_path . $admin_dir_name . '/bin_draft_updated.php') ||
            ($request_uri == $p_blog_path . $admin_dir_name . '/bin_draft_preview.php') ||
            ($request_uri == $p_blog_path . $admin_dir_name . '/bin_draft_publish.php')) {
            display_draft_num();
        }
        echo $menu_mod_del;

    // 管理モードじゃない場合(通常のメニュー表示)
    } else {
        echo "\n".'<ul class="menu">'."\n";
        if(isset($_GET['id'])){ 
            $id = addslashes($_GET['id']); 
        }
        foreach ($menu_list as $key => $value) {
            if ((((isset($id)) && ($id != "") && 
                (($request_uri."?id=".$id) == $p_blog_path . preg_replace('/^.\//', '', $value)))) ||
                (((!isset($id)) && ($request_uri == $p_blog_path . preg_replace('/^.\//', '', $value))))) {
                echo '<li class="cur-menu">'.$key."</li>\n";
            } elseif (preg_match('/^http:\/\//', $value)) {
                echo '<li class="menu"><a href="'.$value.'" class="menu">'.$key."</a></li>\n";
            } else { 
                echo '<li class="menu"><a href="'.$cd.'/'.$value.'" class="menu">'.$key."</a></li>\n";
            }
        }
        // user include file - additional content-menu
        show_include_text("menu_list", $admin);
        echo "</ul>\n";
        // user include file - additional menu
        show_include_text("menu_middle", $admin);
    }
    
}



/**
 * User Defined Include Files
 */
function show_include_text($filename, $admin) 
{
    global $cd;
    if ($admin != TRUE) {
        $fp = $cd.'/include/user_include/'.$filename;
        if (file_exists($fp.'.inc.php')) {
            @include_once $fp.'.inc.php';
        } elseif (file_exists($fp.'.inc.txt')) {
            @include_once $fp.'.inc.txt';
        } else {
            // do nothing
        }
    }
}


/**
 * CSS Switcher
 */
function display_css_switch($styles)
{
    global $lang;
    $query_string = htmlspecialchars($_SERVER['QUERY_STRING']);
    echo <<<EOD
<form id="css_form" action="{$_SERVER['PHP_SELF']}?{$query_string}" method="post">
<div class="css-form">
<select tabindex="5" name="style_num" onchange="if(document.forms.css_form.style_num.value != ''){this.form.submit();}">
<option value="">{$lang['switch_css']}</option>
<option value="" disabled="disabled">- - -</option>
EOD;
    foreach($styles as $key => $value){
        echo '<option value="'.$value.'">'.$key."</option>\n";
    }
echo <<<EOD
<option value="off">{$lang['css_off']}</option>
</select>
<noscript> 
<div class="noscript"><input type="submit" accesskey="s" tabindex="6" value="go" /></div>
</noscript>
</div>
</form>
EOD;
}



/**
 * Menu Bottom (with RSS Feed Logo)
 */
function display_menu_bottom($use_rss, $cd, $rss_feed) 
{
    global $admin, $request_uri, $root_path, $top_page, $id;
    if ($use_rss == 'yes') {
        if ($request_uri == 'http://' . $_SERVER["HTTP_HOST"] . $root_path . $top_page) {
            echo '<a href="'.$cd.'/rss/recent.php">'.$rss_feed.'</a>';
        } elseif ($request_uri == 'http://' . $_SERVER["HTTP_HOST"] . $root_path . 'forum/topic.php') {
            echo '<a href="'.$cd.'/rss/1.0.php?tid='.sanitize(abs(intval($_GET['tid']))).'">'.$rss_feed.'</a>';
        } elseif ($request_uri == 'http://' . $_SERVER["HTTP_HOST"] . $root_path . 'forum/index.php') {
            echo '<a href="'.$cd.'/rss/1.0.php?f_index">'.$rss_feed.'</a>';
        }
        /* elseif ($request_uri == 'http://' . $_SERVER["HTTP_HOST"] . $root_path . 'article.php') {
            echo '<a href="'.$cd.'/rss/1.0.php?id='.sanitize(abs(intval($id))).'">'.$rss_feed.'</a>';
        }
        */     
    }
    show_include_text("menu_bottom", $admin);
    echo <<<EOD
</div>
<!-- end-of-menu-box -->
<!-- content-box -->
<div class="content">
EOD;
}


//================================================================
// CONTENT-BOX
//================================================================
/**
 * Article Date Format
 */
//$tz = 9*3600;
function date_format($date_style, $row_name) 
{
    global $row, $formatted_date, $tz;
    switch ($date_style) {
        case '1': // 2003/01/01
            $row[$row_name] = date('Y/m/d g:i:s a', strtotime($row[$row_name]));
//            $row[$row_name] = date('Y/m/d g:i:s a', strtotime($row[$row_name]{$tz}));
//            $row[$row_name] = gmdate('Y/m/d g:i:s a', strtotime($row[$row_name])+$tz);
            $formatted_date = substr($row[$row_name], 0, 10);
            break;
        case '2': // Jan 01, 2003
            $row[$row_name] = date("M d, Y g:i:s a", strtotime($row[$row_name]));
//            $row[$row_name] = date("M d, Y g:i:s a", strtotime($row[$row_name]{$tz}));
//            $row[$row_name] = gmdate("M d, Y g:i:s a", strtotime($row[$row_name])+$tz);
            $formatted_date = substr($row[$row_name], 0, 12);
            break;
        default: // 2003-01-01
//            $row[$row_name] = gmdate("Y-m-d g:i:s a", strtotime($row[$row_name])+$tz);
            $formatted_date = substr($row[$row_name], 0, 10);
            break;
    }
    return $formatted_date;
}

/**
 * Page flipper
 */
function display_page_flip() 
{
    global $page_flip_style, $hit_row, $pagemax, $case, $field, $keyword, $date;
    $keyword = urlencode($keyword);
    if ($hit_row > $pagemax) {
        if ($case == 0) {
//             if ($page_flip_style == '1') {
//                 display_flip_link($field = '', $keyword, $date, $pagemax, $case = '0', $hit_row);
            if ($page_flip_style == '1') {
                if ($date == 'all') {
                   display_flip_link($field = '', $keyword, $date, $pagemax, $case = '0', $hit_row,'no');
                } else {
                   display_flip_link($field = '', $keyword, $date, $pagemax, $case = '0', $hit_row,'yes');
                }
            } else {
                display_flip_form($field = '', $keyword, $date, $pagemax, $case = '0', $hit_row);
            }
        } else {
            if ($page_flip_style == '1') {
                display_flip_link($field = '', $keyword, $date, $pagemax, $case = '1', $hit_row);
            } else {
                display_flip_form($field = '', $keyword, $date, $pagemax, $case = '1', $hit_row);
            }
        }
    }
}

/**
 * Page Flip Style 1 : Link
 * @modified : nakamuxu
 */
function display_flip_link($field, $keyword, $date, $pagemax, $case, $hit_row, $all_flag='yes') 
{
    global $lang, $cd;
    echo "\n".'<p class="flip-link">'."\n";
    $page_array = array();
    $array_key  = 0;
    $pagenumber = 0;
    $datalimit  = 0;
    $result     = 0;
    for ($datalimit; $datalimit < $hit_row; $datalimit += $pagemax) {
        $pagenumber++;
        if (isset($_GET['pn'])) {
            if ($pagenumber == $_GET['pn']) {
                $tag_array["tag"] = '<strong>';
                $tag_array["anchor"] = $pagenumber . '</strong>';
                $page_array[] = $tag_array;
                $array_key = count($page_array) == 0 ? 0 : count($page_array) - 1;
            } else {
                $tag_array["tag"] = '<a href="' . $_SERVER['PHP_SELF'] . '?'.
                'k='       .$keyword.
                '&amp;d='  .$date.
                '&amp;p='  .$datalimit.
                '&amp;pm=' .$pagemax.
                '&amp;pn=' .$pagenumber.
                '&amp;c='  .$case.
                '&amp;f='.
                '">';
                $tag_array["anchor"] = $pagenumber. '</a>';
                $page_array[] = $tag_array;
            }
        }
    }
    if ($array_key > 0) {
        echo '<span class="navi-menu">'.$page_array[$array_key-1]["tag"].
             // '&lt;&lt;&nbsp;' .$lang['prev'].
             '<img src="' . $cd . '/images/arrow_left.png" width="9" height="11" alt="&lt;" />'.
             "</a></span>&nbsp;\n";
    }
    if ($all_flag == 'yes') {
        foreach($page_array as $value) {
            echo $value["tag"];
            echo $value["anchor"]."&nbsp;\n";
        }
    }
    if (isset($_GET['pn']) && $_GET['pn'] != $pagenumber) {
        echo '<span class="navi-menu">'.$page_array[$array_key+1]["tag"].
             // $lang['next'] . '&nbsp;&gt;&gt;';
             '<img src="' . $cd . '/images/arrow_right.png" width="9" height="11" alt="&gt;" />'.
             "</a></span>\n";
    }
    echo "\n</p>\n";
}


/* Page Flip Style 2 : Form */
function display_flip_form($field, $keyword, $date, $pagemax, $case, $hit_row) 
{
    global $lang;
    echo <<<EOD

<form action="{$_SERVER['PHP_SELF']}" method="get">
<div class="flip-form">
<input type="hidden" name="k" value="{$keyword}" />
<input type="hidden" name="d" value="{$date}" />
<select class="resultchange" name="p" tabindex="1" onchange="this.form.submit()">
<option value="">{$lang['flip_pages']}</option>
EOD;
        //(1)separate the hit data
        //(2)->increase the option tags to the result
        $pagenumber = 0;
        $datalimit  = 0;
        $result     = 0;
        for ($datalimit; $datalimit < $hit_row; $datalimit += $pagemax) {
            $pagenumber += 1;
            $result = $datalimit+1;
            echo '<option value="'.$datalimit.'">'.$result.' - (  P '.$pagenumber." )</option>\n";
        }
echo <<<EOD
</select>
<input type="hidden" name="pm" value="{$pagemax}" />
<input type="hidden" name="pn" value="" />
<input type="hidden" name="c" value="{$case}" />
<input type="hidden" name="f" value="{$field}" />
<noscript> 
<div class="noscript"><input type="submit" accesskey="f" tabindex="2" value="{$lang['flip']}" /></div>
</noscript>
</div>
</form>

EOD;
}


/**
 * Previous Logs Navi Link
 */
function display_prev_logs_navi($file) 
{
    global $lang, $root_path, $pagemax, $cd, $rows;
    echo '<p class="prev-logs">'."\n".
         '<a href="http://' .$_SERVER['HTTP_HOST'] . $root_path . $file . '.php?'.'k=&amp;p='.$pagemax.'&amp;c=0&amp;pn=2&amp;d=all">'.
         $lang['prev_logs']. 
         // '&nbsp;&nbsp;&gt;'. // text arrow
         '&nbsp;&nbsp;<img src="' . $cd . '/images/arrow_right.png" width="9" height="11" alt="&gt;" />'. // image arrow
         '</a>'.
         "</p>\n";
}

//================================================================
// FOOTER-BOX
//================================================================
/**
 * Generate Footer Box
 */
function footer() 
{
    global $lang, $footer_type, $root_path, $style_num, $style,
           $cd, $copyright, $show_generation_time, $begin_time_str, $admin; 
    if ($footer_type == 1) {
        display_footer($cd);
    } elseif ($footer_type == 2) {
        display_valid_footer($root_path, $style_num, $style, $cd);
    } elseif ($footer_type == 3) {
        display_w3c_valid_footer($root_path, $style_num, $style, $cd);
    } else {
        display_user_footer($admin=FALSE);
    }
}


/**
 * Footer Style 1 : Default Footer
 */
function display_footer($cd) 
{
    global $copyright, $show_generation_time, $begin_time_str;
    echo "\n";
    echo <<<EOD
<!-- footer-box -->
<div class="footer-box">
<a href="http://pbx.homeunix.org/p_blog/index.php">
<img src="{$cd}/images/p_blog_logo.png" width="88" height="31" alt="p_blog" class="logo" />
</a>
{$copyright}. All rights reserved.<br />
<script type="text/javascript">js_email_link();</script>
<noscript>
  <div class="no-js-email">
    &lt;JavaScript must be &quot;on&quot; to display the email address.&gt;
  </div>
</noscript>
</div>
EOD;
    if ($show_generation_time == 'yes') {
        display_gt($begin_time_str);
    }
    echo "</div>\n</body>\n</html>";
}



/**
 * Footer Style 2 : with P_BLOG Original Validator Logos
 */
function display_valid_footer($root_path, $style_num, $style, $cd) 
{
    global $debug_mode, $custom_ahl_path, $xml_version, $copyright, $show_generation_time, $begin_time_str;
    switch ($xml_version) {
        case '1.1':
            $logo_src = 'valid_xhtml11.png';
            $logo_alt = 'Valid XHTML1.1';
            break;
        default:
            $logo_src = 'valid_xhtml10.png';
            $logo_alt = 'Valid XHTML1.0';
            break;
    }
    if ($debug_mode == 'on') {
        $ahl_path = $custom_ahl_path;
    } else {
        $ahl_path = 'http://openlab.ring.gr.jp/k16/htmllint/htmllint.cgi';
    }
    echo <<<EOD
<div class="footer-box">
<a href="http://validator.w3.org/check/referer">
<img src="{$cd}/images/{$logo_src}" width="88" height="31" alt="{$logo_alt}" class="validator" />
</a>
<a href="http://jigsaw.w3.org/css-validator/validator?uri=http://{$_SERVER['HTTP_HOST']}{$root_path}styles/{$style_num}/{$style}.css">
<img src="{$cd}/images/valid_css.png" width="88" height="31" alt="Valid CSS" class="validator" />
</a>
<a href="{$ahl_path}?ViewSource=on">
<img src="{$cd}/images/ahl.png" width="88" height="31" alt="AHL" class="validator" />
</a>
EOD;
    show_include_text("user_footer", $admin=FALSE);
    echo "<br />{$copyright}. All rights reserved. ".
         'Powered by <a href="http://pbx.homeunix.org/p_blog/index.php" title="P_BLOG project">P_BLOG</a>.</div>';
    if ($show_generation_time == 'yes') {
        display_gt($begin_time_str);
    }
    echo "</div>\n</body>\n</html>";
}


/**
 * Footer Style 3 : with W3C Original Validator Logos
 */
function display_w3c_valid_footer($root_path, $style_num, $style, $cd) 
{
    global $xml_version, $copyright, $show_generation_time, $begin_time_str, $admin;
    switch ($xml_version) {
        case '1.1':
            $logo_src = 'valid-xhtml11.png';
            $logo_alt = 'Valid XHTML1.1';
            break;
        default:
            $logo_src = 'valid-xhtml10.png';
            $logo_alt = 'Valid XHTML1.0';
            break;
    }
    echo <<<EOD
<div class="footer-box">
<a href="http://validator.w3.org/check/referer">
<img src="{$cd}/images/{$logo_src}" width="88" height="31" alt="$logo_alt" class="validator" />
</a>
<a href="http://jigsaw.w3.org/css-validator/validator?uri=http://{$_SERVER['HTTP_HOST']}{$root_path}styles/{$style_num}/{$style}.css">
<img src="{$cd}/images/valid-css.png" width="88" height="31" alt="Valid CSS" class="validator" />
</a>
<a href="http://www.w3.org/Style/CSS/Buttons">
<img src="{$cd}/images/mwcts.png" width="88" height="31" alt="CSS" class="validator" />
</a>
EOD;
    show_include_text("user_footer", $admin=FALSE);
    echo "<br />{$copyright}. All rights reserved. ".
         'Powered by <a href="http://pbx.homeunix.org/p_blog/index.php" title="P_BLOG project">P_BLOG</a>.</div>';
    if ($show_generation_time == 'yes') {
        display_gt($begin_time_str);
    }
    echo "</div>\n</body>\n</html>";
}


/**
 * Footer Style 4 : User Custom Footer
 */
function display_user_footer($admin) 
{
    global $show_generation_time, $begin_time_str;
    echo "\n".'<div class="footer-box">'."\n";
    show_include_text("user_footer", $admin);
    echo "</div>\n";
    if ($show_generation_time == 'yes') {
        display_gt($begin_time_str);
    }
    echo "</div>\n</body>\n</html>";
}


/**
 * Page Generation Time
 * @author : nakamuxu
 */
function microtime_to_microseconds($microtime) 
{
    $tmp_array = explode(" ", $microtime);
    return (((float)$tmp_array[0]) + ((float)$tmp_array[1]));
}

function between_microseconds($begin_str, $finish_str) 
{
    $begin_microseconds = microtime_to_microseconds($begin_str);
    $finish_microseconds = microtime_to_microseconds($finish_str);
    return ($finish_microseconds - $begin_microseconds);
}

function display_gt($begin_time_str) 
{
    $finish_time_str = microtime();
    $lapsed_time = between_microseconds($begin_time_str, $finish_time_str);
    echo '<p class="page-generation">Page generation&nbsp;:&nbsp;'.number_format($lapsed_time, 4).'&nbsp;seconds.</p>';
}


//================================================================
// SECURITY
//================================================================
/**
 * Against XSS
 * @author : nakamuxu
 */
function against_xss() 
{
    switch ($_SERVER['REQUEST_METHOD']) {
	    case 'POST':
    	    foreach ($_POST as $key => $value) {
	    		if (is_array($value)) {
		    	    array_walk($value, "htmlspecialchars");
			    	$_REQUEST[$key] = $value;
    			} else {
	    	        $_REQUEST[$key] = htmlspecialchars(trim($value), ENT_QUOTES);
		        }
    		}
	    	break;
    	case 'GET':
	    	foreach ($_GET as $key => $value) {
		        if (is_array($value)) {
		            array_walk($value, "htmlspecialchars");
    				$_REQUEST[$key] = $value;
	    	    } else {
		            $_REQUEST[$key] = htmlspecialchars(trim($value), ENT_QUOTES);
		        }
    		}
	    	break;
    }
}

// For Main Log
// Insert strings with XHTML tags
function insert_tag_safe($str) 
{
    if (get_magic_quotes_gpc() == 1) {
        $str = trim($str);
        return $str;
    } else {
        $str = addslashes(trim($str));
        return $str;
    }
}


// For FORUM
// Insert strings without XHTML tags
function insert_safe($str) 
{
    if (get_magic_quotes_gpc() == 1) {
        $str = strip_tags(trim($str));
        return $str;
    } else {
        $str = addslashes(strip_tags(trim($str)));
        return $str;
    }
}

// sanitize the string
function sanitize($str) 
{
    if (get_magic_quotes_gpc() == 1) {
        $str = htmlspecialchars(stripslashes($str));
        return $str;
    } else {
        $str = htmlspecialchars($str);
        return $str;
    }
}

/**
 * Validate E-Mail Format
 *
 */
function valid_email($mail) 
{
    if (!preg_match('/^[^@\s]+@([-a-z0-9]+\.)+[a-z]{2,}$/i', $mail)) {
        return 1;
    } else {
        return 0;
    }
}


// Deny direct access to this file
if (stristr($_SERVER['PHP_SELF'], ".inc.php")) {
    header("HTTP/1.1 301 Moved Permanently");
    header("Location: http://" . $_SERVER['SERVER_NAME'] . dirname($_SERVER['REQUEST_URI']) . "/index.php");
}
?>