<?php
/**
 * P_BLOG ユーザー設定ファイル(日本語版)
 *
 * ** 重要 **
 * - このファイルは、編集終了後は 「user_config.inc.php」 と名称を変更してご使用下さい。
 * - P_BLOGのファイル群の文字コードは全てUTF-8、改行コードはLF(Unix改行コード)です。
 * - 編集にはUTF-8を扱えるエディタをご使用下さい。
 *
 * $Id: include/user_config.inc.php, 2004/05/08 18:34:18 Exp $
 */

///////  設定インデックス  ////////
//
// MySQLの設定
// 基本設定
// ヘッダボックス部の設定
// メニューボックス部の設定
// コンテンツボックス部の設定
// フッターボックスの設定
// 記事の個別表示時の設定
// 管理者モードの設定
/////////////////////////////////

//================================================================
// MySQLの設定
//================================================================
// MySQLデータベースの設定です。
// 特に変更が必要でない場合はここはそのままにしておいて下さい。
//------------------------------------------------------------------------------------------------
$dbname          = 'p_blog';        // あなたのMySQLデータベース
$log_table       = 'p_blog_log';    // メインのログテーブル
$info_table      = 'p_bin';         // バイナリ(ファイル)アップローダーのメタデータ用テーブル
$data_table      = 'p_bin_data';    // バイナリ(ファイル)アップローダーの実データ用テーブル
$analyze_table   = 'p_anama';       // アクセス解析機能用テーブル
$user_table      = 'p_blog_user';   // ユーザーテーブル


// MySQLのユーザー設定
// -----------------------------------------------------------------------------------------------
$host            = 'localhost';     // PHPから見たMySQLのホスト名またはIPアドレス。PHPとMySQLが同一サーバーにある場合はそのままにしておいて下さい。
$user            = 'mysql-user';    // あなたのMySQLユーザー名
$password        = 'mysql-pass';    // あなたのMySQLパスワード


// あなたのMySQLデータベースの使用言語
// * 例:
// * 英語の場合  : Latin1 あるいは ISO-8859-1 など
// * 日本語の場合 : EUC-JP あるいは SJIS など
// -----------------------------------------------------------------------------------------------
$mysql_lang      = 'EUC-JP';

// データ数カウント用クエリのカスタマイズ
// 特に必要がなければここはそのままにしておいてください。
// -----------------------------------------------------------------------------------------------
// $count_row_query = 'found_rows()'; // MySQL-4.0.x 以上のみ
$count_row_query = 'id';             //  MySQL-3.23.5x 以上


//================================================================
// 基本設定
//================================================================
///////////////////// 重要 ///////////////////
// * ここはサーバー名から下のあなたのP_BLOGのルートパスを記述します。
// * ** 前後にスラッシュを必ずスラッシュを入れて下さい! **
// -----------------------------------------------------------------------------------------------
// 例:
// * $root_path  = '/p_blog/';                     <-- o 良い例 !
// * $root_path  = 'http://yourdomain.com/p_blog'; <-- x 悪い例 !
// -----------------------------------------------------------------------------------------------
$root_path       = '/path/to/your/p_blog/';


// P_BLOGのトップページです。
// * 特に必要なければそのままにしておいて下さい。
// -----------------------------------------------------------------------------------------------
$top_page        = 'index.php';



// XHTMLの言語設定
// * 出力するXHTMLの文字コードを設定します。(UTF-8推奨)
// -----------------------------------------------------------------------------------------------
$xml_version          = '1.0';
$xml_lang             = 'ja';       // 例: 英語 = 'en', 日本語 = 'ja', イタリア語 = 'it';
$charset              = 'utf-8';    // 例: iso-8859-1, euc-jp



// UTF-8 (マルチバイト) 変換機能
// * "ON" 推奨です.
// * ONの場合はUTF-8が出力されます。
// * OFFの場合はMySQLのエンコードがそのまま出力されます。
// * あなたのサーバーのPHPがマルチバイトをサポートしていない、という場合などのように
//   特に必要がなければここは「ON」にしておいて下さい。
// -----------------------------------------------------------------------------------------------
$enable_unicode       = 'on';        //use UTF-8 convert --- 'on' or 'off'


//================================================================
// ヘッダボックス部の設定
// * あなたのP_BLOGの名称設定など
//================================================================
// タイトルとサブタイトルの設定
// -----------------------------------------------------------------------------------------------
$blog_title      = 'P_BLOG';
$sub_title       = '- Simple &amp; W3C-Valid Log System';

// SEARCH Plus+ (詳細検索) アンカー
// * 詳細検索画面での右角コーナーのアンカー
// -----------------------------------------------------------------------------------------------
// * スタイル-1 : テキストリンクを使用
// $search_plus_anchor = '<span class="search-plus">&raquo;</span>';
// * スタイル-2 : 画像を使ったリンクその1
// $search_plus_anchor = '<img src="./images/arrow2.png" width="9" height="11" alt="&raquo;" />';
// * スタイル-3 : 画像を使ったリンクその2
$search_plus_anchor = '<img src="'.$cd.'/images/arrow.png" width="16" height="16" alt="&raquo;" />';

 
//================================================================
// メニューボックス部の設定
//================================================================
// コンテンツメニュー
// * パターン: "Title" => "File path"
// -----------------------------------------------------------------------------------------------
$vars_page_title = 'VARS'; // 「VARS」ページの名称を設定

// コンテンツメニューのリスト
$menu_list = array(
    "LOGS"               => "index.php",
    "FILES"              => "files/index.php",
    "{$vars_page_title}" => "var/index.php");
 

// **( オプション1 )**
// * フォーラム機能を試用する場合はリンクを追加して下さい。メニューからフォーラムに飛べるようになります。
// * 例：
// *  
// *  "FORUM" => "forum/index.php",
// *
// **( オプション2 )**
// * フィードバックフォームを使うときは以下の文を付け加えてください。メニューからフォームが選べるようになります。
// * "CONTACT" => "var/index.php?id=feedback_ja",


// CSS スイッチ
// -----------------------------------------------------------------------------------------------
$use_css_switch  = 'yes';          // CSSスイッチを -- 「yes」 か 「no」を選択
$css_cookie_name = 'p_blog_style'; // あなたのP_BLOGのCSSクッキー名を設定
$css_cookie_time = '15724800';     // クッキーの有効期限(秒)
$default_style   = 'rich_green';   // デフォルトCSSの設定

// CSSをカスタマイズしたり追加した場合はこちらで名称を設定して下さい。
// パターン: "Title" => "CSS folder name"
$styles = array(
    "W3C Silk"   => "w3c_silk",
    "Alminum"    => "alminum",
    "Rich Green" => "rich_green");
    

// RSS フィード
// -----------------------------------------------------------------------------------------------
$use_rss  = 'yes'; // RSSを出力 --- する:yes  しない:no


// * RSSフィードのリンクを、テキストあるいは画像のどちらを使うか選択
// * $rss_feed = 'XML/RSS'; // テキストを使ったリンク
$rss_feed = '<img src="'.$cd.'/images/rss_rdf.png" '.
                 'width="80" height="15" '.
                 'alt="rss" title="RDF of this page" class="logo" />';


// * 各記事の個別リンクを、テキストあるいは画像のどちらを使うか選択
// $anchor = '@';       // テキストを使ったリンク例その1
// $anchor = '&oplus;'; // テキストを使ったリンク例その2
// -----------------------------------------------------------------------------------------------
$anchor = '<img src="./images/anchor_button5.png" width="12" height="12" alt="&oplus;" class="anchor" />';


//================================================================
// コンテンツボックス部の設定
//================================================================
// 日付タイトル
// * 日付タイトルの表示・非表示設定
// -----------------------------------------------------------------------------------------------
$show_date_title      = 'yes';       // --- する:yes  しない:no

// 各ログに時間を表示
// -----------------------------------------------------------------------------------------------
$show_date_time       = 'yes';       // --- する:yes  しない:no

// 日付タイトルのフォーマット
// * 1     : 2003/01/01
// * 2     : Jan 01, 200
// * 空       : 2003-01-01
// -----------------------------------------------------------------------------------------------
$date_style           = '2';


// 最大記事表示数
// 各ページの最大記事表示数を設定
// -----------------------------------------------------------------------------------------------
$pagemax              = '7';         // デフォルトは7記事表示です。



// ページめくりスタイルの設定
// * 1: リンク 2: フォーム
// -----------------------------------------------------------------------------------------------
$page_flip_style      = '1';



// アーカイブリストフォームの降順表示
// * 'yes'にすると、最新の月が上に来ます。
// -----------------------------------------------------------------------------------------------
$date_order_desc      = 'yes';       // --- する:yes  しない:no



// カテゴリーリストをメニューに表示
// -----------------------------------------------------------------------------------------------
$show_categories      = 'yes';       // --- する:yes  しない:no
$category_style       = '1';         // 1: フォームメニュー  2: リストメニュー
$show_cat_num         = 'yes';       // --- する:yes  しない:no // アーカイブ数を表示するか否か



// 「最近のn件」をメニューに表示
// -----------------------------------------------------------------------------------------------
$show_pre_recent_menu = 'no';       // --- する:yes  しない:no
$pre_recent_max       = '5';        // する場合の表示数




///////////////// MySQLファイルアップローダーの設定 //////////////
//
// ファイルインデックスのタイトル設定
// -----------------------------------------------------------------------------------------------
$file_index_title     = 'FILES';     // ファイルページのタイトル
$use_2_indexes        = 'yes';       // 日付別とカテゴリー別のインデックスを使用 --- する:yes  しない:no
$max_listup           = '2';         // 各カテゴリーごとの表示数

// ファイルのカテゴリーリストを表示
// -----------------------------------------------------------------------------------------------
$show_bin_categories  = 'yes';       // --- する:yes  しない:no
$bin_category_style   = '1';         // 1: フォームメニュー  2: リストメニュー
$show_bin_cat_num     = 'yes';       // カテゴリー毎のデータ数を表示 --- する:yes  しない:no


// Show filetype list in menu
// -----------------------------------------------------------------------------------------------
$show_filetype        = 'no';        // --- 'yes' or 'no'
$filetype_style       = '1';         // 1: Form Menu  2: List Menu
$show_type_num        = 'yes';       // --- 'yes' or 'no' // show how many files are stocked in each filetype


// 日付タイトルを表示
// -----------------------------------------------------------------------------------------------
$show_file_date_title = 'yes';       // --- する:yes  しない:no



// 画像表示の設定
// -----------------------------------------------------------------------------------------------
$show_thumb_nail = 'yes';            // "jpg, gif, png"のサムネールを表示 --- する:yes  しない:no
$thumb_nail_w    = '90';             // サムネールの幅
$thumb_nail_h    = '90';               // サムネールの高さ
$thumb_nail_alt  = 'thumb nail';     // アンカータグのALT
$show_img_size   = 'yes';            // --- する:yes  しない:no


// ファイルのMD5値を表示
// -----------------------------------------------------------------------------------------------
$show_md5             = 'yes';       // --- する:yes  しない:no;


// ファイルダウンロードカウンターを使用
// * ここを'yes'にするとファイルのダウンロード数を記録することが出来ます。
// * ダウンロード数のチェックは管理モードで閲覧出来ます。
// -----------------------------------------------------------------------------------------------
$use_download_counter = 'yes';       // --- する:yes  しない:no;



//================================================================
// フッターボックスの設定
//================================================================
// フッタースタイルを選択
// -----------------------------------------------------------------------------------------------
$footer_type = '1'; //1:デフォルト    2:構文チェッカー付  3:W3Cオリジナルロゴ付  4:ユーザーカスタムフッター

$email           = 'webmaster@example.com';  // E-Mail アドレス


// 「コンタクト」アドレスのタイトル設定 ( フッタータイプ1のみ )
// -----------------------------------------------------------------------------------------------
$email_title     = 'Send Comments';


// あなたの著作権を表示
// -----------------------------------------------------------------------------------------------
$copyright       = 'Copyright &copy; 2003 Me'; // ここの「Me」をあなたの名前に書き換えてください


// [ カスタマイズ例 (フッタータイプ 1 & 2 ) ]
// あなたの使用するサーバーが「Sendmail」や「Postfix」などのメールソフトをサポートしている場合、フィードバックフォームを
// 利用して「コンタクト」を使うことが出来ます。 ↓
// ------------------------------------------------------------------------------------------------
// (ex.1) : 日本語のフィードバックフォーム例
// $copyright = 'Copyright &copy; 2003 '.
//              '<a href="http://'.$_SERVER['HTTP_HOST'].$root_path.'var/index.php?id=feedback_ja">Me</a>';
//
// ------------------------------------------------------------------------------------------------
// (ex.2) : 英語のフィードバックフォーム例
// $copyright = 'Copyright &copy; 2003 '.
//              '<a href="http://'.$_SERVER['HTTP_HOST'].$root_path.'/var/index.php?id=feedback_en">Me</a>';
// ------------------------------------------------------------------------------------------------



// ページベンチマークを表示
// * ページの生成時間をページの一番下に表示します
// -----------------------------------------------------------------------------------------------
$show_generation_time = 'yes';   // --- する:yes  しない:no




//================================================================
// 記事の個別表示時の設定
//================================================================
// 記事を個別表示した際にリファレンス用の記事のURIを自動出力表
$display_log_uri = 'no'; // --- する:yes  しない:no



//================================================================
// 管理者モードの設定
//================================================================
/////////////////////  注意事項!  ///////////////////
// 管理モードのディレクトリ名はデフォルトは「admin」ですが、安全のため変更しておくことを強くお勧めします。
// 自分だけが分かるディレクトリ名に変更することでセキュリティ度がアップします。 
//
// 例：
//
// $admin_dir_name  = 'my_secret_path_to_admin';
//
// あるいは、以下のようにMD5ハッシュなどをディレクトリ名にしても良いでしょう。
//
// $admin_dir_name  = '21232f297a57a5a743894a0e4a801fc3';
//                     (例：これは「admin」という文字のMD5ハッシュ値です) 
// -----------------------------------------------------------------------------------------------
$admin_dir_name     = 'admin';



// ログ添付ファイルアップロード用ディレクトリ ( MySQLを使わないアップロード)
// * 各ログと一緒に添付してアップロードするファイル(画像など)用のディレクトリの設定です。
// * ここは必要なければそのままにしておいてください。
// -----------------------------------------------------------------------------------------------
$uploaddir       = '../resources/'; // 書き込み出来るように、パーミッションは "777" に設定しておきます

// 最大画像(ファイル)アップロード数
// * 添付ファイルをログごとにいくつアップロード出来るようにするかを設定します。設定した数のフォームが表示されます。
// * 画像を多めにアップロードしたりする人はここは多めの数値に設定しておくと良いでしょう。
// -----------------------------------------------------------------------------------------------
$up_img_max      = '3';   // デフォルトは3つの画像(ファイル)がアップロード出来ます。



// アクセス解析機能を使用
// -----------------------------------------------------------------------------------------------
$use_analyzer       = 'yes'; // --- する:yes  しない:no

// リファラーの表示最小値を設定
// * ここに設定した数値以下のリファラーは「Others(その他)」としてまとめてカウントされ、解析されます。
// * たとえば「3」とすると、3回以下しかアクセスのないリファラーは「その他」としてまとめられます。
// -----------------------------------------------------------------------------------------------
$referer_limit_num  = '1';   // 最小値: 1


// 「ログを削除」ボタンを表示
// * ここを'yes'にすると、ログ削除ボタンが表示されます。
// * 簡単に全てのログを削除出来てしまうため、デフォルトは「no」です。注意してご使用下さい。
// -----------------------------------------------------------------------------------------------
$enable_del_logs    = 'yes';    // --- する:yes  しない:no
$del_magic_words    = 'flush!'; // 削除する際に入力するマジックワードを設定してください


// Gunzip 圧縮出力
// -----------------------------------------------------------------------------------------------
$gz_compress        = 'yes';  // --- する:yes  しない:no  


////////////////////  メール送信機能  (オプション) ///////////////////
//
// ユーザーアカウントを登録した際に、そのアドレス宛にメールで通知
// (あなたのサーバーがSendmailやPostfixをサポートしている場合のみ使用出来ます)
// -----------------------------------------------------------------------------------------------
$sendmail_account_id  = 'no';  // --- する:yes  しない:no


// フィードバックメールを使用
// -----------------------------------------------------------------------------------------------
$use_feedback_form    = 'no';  // --- する:yes  しない:no


// 「email」リンクを各ログの下に表示
// * この機能はまだα(アルファ)テスト段階ですので注意してご使用下さい
// -----------------------------------------------------------------------------------------------
$use_email_link       = 'no';  // --- する:yes  しない:no


// Sendmail / Postfix 用のE-Mailアドレス
// * このメールアドレスはユーザーアカウント、フィードバックメールを送信する際に使われるメールアドレスです。
// * SendmailやPostfixなどのサーバーのメール送信ソフトを経由して送信されます。
// * このアドレスは公開されません。
// -----------------------------------------------------------------------------------------------
$sendmail_address    = 'yourname@example.com';



////////////////// セッション管理 ////////////////////////////
//
// セッションファイルをMySQLで管理
// * ここを'no'にすると、セッションファイルはサーバーマシンの指定したディレクトリに保存されます。
// * セキュリティ向上のため、「yes」(MySQL使用)がデフォルトです。
// -----------------------------------------------------------------------------------------------
$use_session_db        = 'yes';   // --- する:yes  しない:no


// セッションファイルをサーバー指定ディレクトリで管理
// * ここは、上の「セッションファイルをMySQLで管理」をオフにすると自動的に使用されます。
// * セッション名は英数字のみで設定して下さい。
// -----------------------------------------------------------------------------------------------
$p_blog_sess_name      = 'pblogsesssion';
$p_blog_root_sess_name = 'pblogrootsession';


//================================================================
// フォーラム機能
//================================================================
// 各記事に「Post comment」リンクを表示する
// -----------------------------------------------------------------------------------------------
$use_comment_link     =  'yes';

// フォーラムの記事最大表示数。
// -----------------------------------------------------------------------------------------------
$topic_max           =  '12';



//================================================================================================
//                     これでユーザー設定は終了です!
// -----------------------------------------------------------------------------------------------
// 新規インストールの場合
//   - ブラウザで「SETUP_FILES」ディレクトリに移動し、「DB_INSTALL.php」を実行してMySQLデータベースに
//      P_BLOG用のデータベーステーブルをインストールして下さい。
//
// 前のバージョンからのアップグレードの場合
//   - ブラウザで「SETUP_FILES」ディレクトリに移動し、「DB_UPDATE.php」を実行してMySQLデータベースに
//      P_BLOG用のデータベーステーブルをインストールして下さい。
//
// フォーラム+コメント機能をインストールする場合
//   - ブラウザで「forum/SETUP_FILES」ディレクトリに移動し、「DB_INSTALL.php」を実行してMySQLデータベースに
//      フォーラム+コメント用のデータベーステーブルをインストールして下さい。
//
// 設定が終わったら...
//   - 管理者ディレクトリ「admin(あなたの管理ディレクトリ)/login.php」へ移動して書き込みユーザーアカウントを作成して下さい。
//
//   ... ENJOY!
//================================================================================================
//
//==========================================
//以下のコードはこのファイルへの直アクセスをはじく
//ためのコードですので、絶対に削除しないで下さい。
//==========================================
if (stristr($_SERVER['PHP_SELF'], ".inc.php")) {
    header("HTTP/1.1 301 Moved Permanently");
    header("Location: http://" .$_SERVER['SERVER_NAME']. dirname($_SERVER['REQUEST_URI']). "/index.php");
}
?>