<?php
/**
 * Search Plus+ (Advance search) Routine
 * 
 * $Id: search_plus.php, 2004/03/26 16:17:06 Exp $
 */

$cd = '.';
require_once $cd . '/include/config.inc.php';
require_once $cd . '/include/http_headers.inc.php';
require_once $cd . '/include/fnc_logs.inc.php';
require_once $cd . '/include/search_plus.inc.php';
require_once $cd . '/include/fnc_flip_plus.inc.php';
require_once $cd . '/include/fnc_search.inc.php';
require_once $cd . '/include/fnc_error_msgs.inc.php';

session_control();

against_xss();

// XHTML Header
display_header();

// Display Menu
display_menu_list($cd, $admin, $menu_list, $root_path);

// Pick up archives by date
$sql = "SELECT DATE_FORMAT(date,'%Y-%m') as date FROM {$log_table} GROUP BY date ORDER BY date";
if ($date_order_desc == 'yes') {
    $sql.= " DESC";
}
archive_by_date($sql);

// Category List
if ($show_categories == 'yes') {
    if ($category_style == 1) {
        display_categories_menu($show_cat_num, $log_table, $enable_unicode, $mysql_lang);
    } elseif ($category_style == 2) {
        display_categories_list($show_cat_num, $log_table, $enable_unicode, $mysql_lang);
    }
}

// CSS Switcher
if ($use_css_switch == 'yes') { display_css_switch($styles); }

// Menu Bottom
display_menu_bottom($use_rss, $cd, $rss_feed);

//=====================================================
// PREPARE SEARCH QUERY
//=====================================================

if (isset($_GET['f'], $_GET['k'], $_GET['ao'], $_GET['p'], $_GET['ds'], $_GET['d'], $_GET['d1'], $_GET['d2'], $_GET['c'], $_GET['pn'])) {
    // To check if keyword value is not too short
    if (($_GET['k'] != '') && (strlen($_GET['k']) <= 2 )) {
         keyword_error($error_type = '2');
         exit;
    }
    $field = $_GET['f'];
    if ($enable_unicode == 'on') {
        $keyword = mb_convert_encoding(trim($_GET['k']), $mysql_lang, "auto");
    } else {
        $keyword = trim($_GET['k']);
    }
    $ao    = $_GET['ao']; // and or
    $page  = $_GET['p'];  // page
    $date  = $_GET['d'];  // date
    $ds    = $_GET['ds']; // date select
    $d1    = $_GET['d1']; // date 1
    $d2    = $_GET['d2']; // date 2
    $case  = $_GET['c'];  // case-insensitive (c = 0) or sensitive ( c = 1)
    
    if ($field != '') {
        $sql = "SELECT";
        $sql.= " id,href,name,DATE_FORMAT(date, '%Y-%m-%d') as date,DATE_FORMAT(mod,'%Y-%m-%d %T') as mod,comment,category";
        $sql.= " FROM {$log_table} WHERE (";
        if (($field != '0') && ($keyword != '')) { // keyword search
            // Keywords
            if (!strrchr($keyword, " ")) {
                $keys = explode(",", $keyword);
                $and_or = $ao;
            } else {
                $keys = explode(" ", $keyword);
                $and_or = $ao;
            }
            if ($case == 1) { $sql .= "BINARY "; }
            switch ($field) {
                case '2':
                    $sql .= "name";
                    break;
                case '3':
                    $sql .= "href";
                    break;
                case '4':
                    $sql .= "comment";
                    break;
                default:
                    $sql .= "name LIKE '%".$keys[0]."%' OR ";
                    if ($case == 1) { $sql .= "BINARY "; }
                    $sql .= "comment";
            }
            $sql .= " LIKE '%".$keys[0]."%')";
            for ($i = 1; $i < sizeof($keys); $i++) {
                $sql .= $and_or. ' (';
                if ($case == 1) { $sql .= "BINARY "; }
                switch ($field) {
                    case '2':
                        $sql .= "name";
                        break;
                    case '3':
                        $sql .= "href";
                        break;
                    case '4':
                        $sql .= "comment";
                        break;
                    default:
                        $sql .= "name LIKE '%".$keys[$i]."%' OR ";
                        if ($case == 1) { $sql .= "BINARY "; }
                        $sql .= "comment";
                }
                $sql .= " LIKE '%".$keys[$i]."%')";
            }
            // Date
            switch ($ds) {
                case '0':
                    break;
                case '1':
                    $sql .= " AND (date LIKE '".$date."%')";
                    break;
                case '2':
                    $sql .= " AND (date BETWEEN '".$d1."' AND '".$d2."')";
                    break;
                default:
                    $sql .= " AND (date LIKE '".$date."%')";
            }
            // Category
            if ((isset($_GET['cat'])) && ($_GET['cat'] != '')) {
                $cat   = array($_GET['cat']);
                if (is_array($cat[0])) {
                    $sql .= ' AND (';
                    $sql .= "category LIKE '%".$cat[0][0]."%'";
                    for ($j = 1; $j < sizeof($cat[0]); $j++) {
                        $sql .= " OR category LIKE '%".$cat[0][$j]."%'";
                    }
                    $sql .= ')';
                }
            }
        } elseif (($field == '0') && ($keyword == '')) { // monthly search
            $sql .= "date LIKE '".$date."%')";
        }
        $sql .= " ORDER BY date DESC LIMIT {$page}, {$pagemax} ";
    } else {
        // Error
        no_keywords_error();
        exit;
    }  
 
    //=====================================================
    // SUBMIT SEARCH QUERY
    //=====================================================
    if ($res = mysql_query($sql)) {
        //query results --- count all hit data
        // Keywords
        if (!strrchr($keyword, " ")) {
            $keys = explode(",", $keyword);
            $and_or = $ao;
        } else {
            $keys = explode(" ", $keyword);
            $and_or = $ao;
        }
        $count_sql = "SELECT id, DATE_FORMAT(date, '%Y-%m-%d') FROM {$log_table} WHERE (";
        if ($case == 1) {
            $count_sql .= "BINARY ";
        }
        switch ($field) {
            case '2':
                $count_sql .= "name";
                break;
            case '3':
                $count_sql .= "href";
                break;
            case '4':
                $count_sql .= "comment";
                break;
            default:
                $count_sql .= "name LIKE '%".$keys[0]."%' OR ";
                if ($case == 1) { $sql .= "BINARY "; }
                $count_sql .= "comment";
        }
        $count_sql .= " LIKE '%".$keys[0]."%')";  
        for ($i = 1; $i < sizeof($keys); $i++) {
            $count_sql .= $and_or . ' (';
            if ($case == 1) {
                $count_sql .= "BINARY ";
            }
            switch ($field) {
                case '2':
                    $count_sql .= "name";
                    break;
                case '3':
                    $count_sql .= "href";
                    break;
                case '4':
                    $count_sql .= "comment";
                    break;
                default:
                    $count_sql .= "name LIKE '%".$keys[$i]."%' OR ";
                    if ($case == 1) { $sql .= "BINARY "; }
                    $count_sql .= "comment";
            }
            $count_sql .= " LIKE '%".$keys[$i]."%')";
        }
        // Date
        switch ($ds) {
            case '0':
                break;
            case '1':
                $count_sql .= " AND (date LIKE '".$date."%')";
                break;
            case '2':
                $count_sql .= " AND (date BETWEEN '".$d1."' AND '".$d2."')";
                break;
            default:
                $count_sql .= " AND (date LIKE '".$date."%')";
        }
        // Category
        if ((isset($_GET['cat'])) && ($_GET['cat'] != '')) {
            $cat   = array($_GET['cat']);
            if (is_array($cat[0])) {
                $count_sql .= ' AND (';
                $count_sql .= "category LIKE '%".$cat[0][0]."%'";
                for ($j = 1; $j < sizeof($cat[0]); $j++) {
                    $count_sql .= " OR category LIKE '%".$cat[0][$j]."%'";
                }
                $count_sql .= ')';
            }
        }
        $hit_res = mysql_query($count_sql);
        $hit_row = mysql_num_rows($hit_res);
    
        // Show the hit data info.
        $rows = mysql_num_rows($res);
        if ($enable_unicode == 'on') {
            $keyword = mb_convert_encoding($keyword, "UTF-8", $mysql_lang);
        }
        if ($keyword == '') {
            if ($date != '') {
                echo '<h2 class="archive-title">'.$date."</h2>\n";
            } else {
                echo '<h2 class="archive-title">'.$lang['all_data']."</h2>\n";
            }
            $disp_page = $page + 1;
            $disp_rows = $page + $rows;
            echo '<p class="search-res">'.
                 '<span class="search-res">'.$hit_row.'</span>'.$lang['show_log'].'&nbsp;'.
                 '<span class="search-res">'.$disp_page.' - '.$disp_rows.'</span> / '.
                 '<span class="search-res">'.$hit_row.'</span></p>';
        } elseif ($keyword != '') {
            echo '<h2 class="archive-title">'.$lang['keyword'];
            echo ' : '.htmlspecialchars(stripslashes($keyword))."</h2>\n<p>\n";
            switch ($field) {
                case '2':
                    echo $lang['title_hit'];
                    break;
                case '3':
                    echo $lang['uri_hit'];
                    break;
                case '4':
                    echo $lang['comment_hit'];
                    break;
                default:
                    echo $lang['title_comment_hit'];
            }
            $disp_page = $page + 1;
            $disp_rows = $page + $rows;
            echo '<span class="search-res">'.$hit_row.'</span> '.$lang['hit_msg'].'&nbsp;'.
                 '<span class="search-res">'.$disp_page.' - '.$disp_rows.'</span> / '.
                 '<span class="search-res">'.$hit_row."</span>\n";
            switch ($ds) {
                case '0':
                    echo "</p>\n";
                    break;
                case '1':
                    echo '&nbsp;&nbsp;&nbsp;&nbsp;'.$lang['by_month'].'：<span class="search-res">'.$date."</span>\n</p>\n";
                    break;
                case '2':
                    echo "</p>\n<p>".$lang['by_month'].'：<span class="search-res">'.$d1.'</span> - <span class="search-res">'.$d2."</span>\n</p>\n";
                    break;
                default:
                    echo "</p>\n";
            }
        }
        //=================================================
        // SHOW THE RESULTS!
        //=================================================
        if ($hit_row) {
            display_page_flip_plus();
            //------------- WITH-DATE-TITLE MODE --------------
            if ($show_date_title == 'yes') {
                $row = mysql_fetch_array($res);
                // $title_date = substr($row['date'], 0, 10);
                date_format($date_style, $row_name = 'date');
                $title_date = $formatted_date;
                echo '<h2 class="date-title">'.$title_date."</h2>\n";
                do {
                    // $tmp_date = substr($row['date'], 0, 10);
                    date_format($date_style, $row_name = 'date');
                    $tmp_date = $formatted_date;
                    if ($title_date != $tmp_date) {
                        $title_date = $tmp_date;
                        echo '<h2 class="date-title">'.$title_date."</h2>\n";
                    }
                    hit_key_highlight();
                    convert_to_utf8($enable_unicode, $row, $mysql_lang);
                    display_article_box($row, $anchor);
                } while ($row = mysql_fetch_array($res));
            //------------- WITHOUT-DATE-TITLE MODE --------------
            } else {
                while ($row = mysql_fetch_array($res)) {
                    hit_key_highlight();
                    convert_to_utf8($enable_unicode, $row, $mysql_lang);
                    display_article_box($row, $anchor);
                }
            }
            display_page_flip_plus();
        } else {
            echo '<h3>'.$lang['no_matches']."</h3>\n";
            display_search_plus($sql, $show_cat_num, $log_table, $enable_unicode, $mysql_lang);
        }
    } else {
        no_keywords_error();
        exit;
    }
} else {
    // Show the default interface
    echo '<h2 class="archive-title">SEARCH PLUS+</h2>';
    display_search_plus($sql, $show_cat_num, $log_table, $enable_unicode, $mysql_lang);
}
footer();
?>
