<h1><?= P_BLOG_VERSION ?> マニュアル</h1>
<hr />
<p class="flip-menu">
<a href="./index.php">TOP</a> <a href="./index.php?id=ja_00">索引</a> <span class="cur-tab">XHTMLのカスタマイズ</span></p>
<hr />
<h2>XHTMLのカスタマイズ</h2>
<h3>ユーザーメニューのカスタマイズ</h3>
<p>ユーザー定義のメニューを、メニューの真ん中、下、コンテンツの上に表示することが出来ます。アンテナや独自のリンク、情報などを表示したい場合に使えます。</p>
<h4>ファイル本体はどこにある？</h4>
<p>「<span class="blue">include/user_include</span>」内にあります。それぞれのファイル名はその表示される場所を示しています。</p>
<p>
<span class="red">(例)</span><br />
「<span class="blue">menu_bottom</span>.inc.txt-sample」=&gt;「<span class="blue">メニューの下</span>」
</p>
<h4>どうやったら有効になる?</h4>
<p>拡張子の後についている「<span class="red">-sample</span>」を取ると、自動的に表示されるようになります。</p>

<h3>ベースのXHTMLを独自にカスタマイズしたい</h3>
<p>P_BLOGでは、各ページ内でのPHP処理コードとXHTMLタグの混在を極力減らし、出力されるタグは極力関数化し、「<strong>include/</strong><span class="blue"><strong>fnc_</strong></span>」で始まるファイルにまとめるようにしていますので、必要な場合はこれらのファイルを参照して下さい。</p>
<p>出力タグのクラス付けやマークアップは極力汎用性を持たせるように心掛けていますが、使用環境、あるいはデザインの変更等によってタグのクラスや構造をカスタマイズしたい、という場合もあると思います。その場合は、<span class="blue"><strong>「fnc_*.inc.php」</strong></span>の各関数に含まれるXHTMLコードをカスタマイズして下さい。</p>
<p>コーディングスタイルですが、視認性を高めるためにXHTML部分は極力ヒアドキュメントを使用、XHTMLコード部分を示すIDは「 <span class="blue">EOD</span> 」で、PHPの変数はカーリーブラケットで括る、という以下のようなスタイルをとっています。</p>
<div class="command">
<pre><span class="blue">echo&nbsp;&lt;&lt;&lt;EOD</span>
&lt;tag&gt;XHTMLのコンテント記述部分{<span class="red">$PHPの変数</span>}&lt;/tag&gt;
&lt;tag&gt;XHTMLのコンテント記述部分{<span class="red">$PHPの変数</span>}&lt;/tag&gt;
&lt;tag&gt;XHTMLのコンテント記述部分{<span class="red">$PHPの変数</span>}&lt;/tag&gt;
<span class="blue">EOD;</span>
</pre>
</div>
<p>入り込んだ条件分岐や定数を使った処理の部分では必要に応じて他のスタイルを使っているところもあります。</p>
<h3>タグカスタマイズ時の注意点</h3>
<p>タグをカスタマイズする際、起こる可能性が高いエラーとしては、</p>
<ul>
<li>うっかり必要なPHPコード部分を消去してしまう</li>
<li>ダブルクォート内で展開される処理に必要な、クォートの前のバックスラッシュが入っていない</li>
</ul>
<p>が挙げられると思います。それを防ぐためにも、直接オリジナルを改変するのではなくその関数部分をコピーしたものを改変し、オリジナルはコメントアウトして残しておく等、いつでもすぐに元に戻せて変更の適用具合を参照出来る選択肢を残しておいて下さい。</p>
<h3>P_BLOGのXHTML構造は？</h3>
<p><a href="./contents/xhtml_class_chart.html">P_BLOG XHTML構造CSSクラス早見表</a>をご参照ください。</p>
<hr />
